#!/bin/bash
LOGFILE=/var/log/fanspeed.log
ECFILE=/home/gregor/4530s/FanControl/probook_ec.pl
COUNTER=60

######################################################

initOff()
{
  setFan 80
  sleep 2
  $ECFILE FANOFF
}

setFan()
{
  SPEED=$1
  $ECFILE := 0x2F $SPEED
}

getTempAvg()
{
  CUR=0
  CPUTEMP=0
  MAX=$1
  while [ $CUR -lt $MAX ]
  do
    TMP=$(sensors | grep Physical | cut -b 18-19)
    let CPUTEMP=$CPUTEMP+$TMP
    let CUR=$CUR+1
    sleep 1
  done
  let CPUTEMP=$CPUTEMP/$MAX
}

detectNewSpeed()
{
  CPUTEMP=$1
  CNTMAX=$2
  INTERVAL=$3
  if [ $CPUTEMP -le 55 ]
  then
    if [ $COUNTER -ge $CNTMAX ]
    then
      NEWSPEED=FF
    else
      NEWSPEED=80
      let COUNTER=$COUNTER+$INTERVAL
    fi
  else
    let COUNTER=0
    if [ $CPUTEMP -ge 80 ]
    then
      NEWSPEED=0
    elif [ $CPUTEMP -ge 75 ]
    then
      NEWSPEED=49
    elif [ $CPUTEMP -ge 70 ]
    then
      NEWSPEED=59
    elif [ $CPUTEMP -ge 65 ]
    then
      NEWSPEED=65
    elif [ $CPUTEMP -ge 60 ]
    then
      NEWSPEED=74
    elif [ $CPUTEMP -gt 55 ]
    then
      NEWSPEED=80
    fi
  fi
  echo $1:$NEWSPEED:$2:$COUNTER
  setFan $NEWSPEED
}

##################################################

initOff

while [ true ]
do
INTERVAL=5
getTempAvg $INTERVAL
detectNewSpeed $CPUTEMP 180 $INTERVAL

done
